#include "GSM_Telit.h"

void ClearUART(){
  UART_Remappable_Read();
  UART_Remappable_Read();
  UART_Remappable_Read();
  CREN2_bit = 0;
  CREN2_bit = 1;
}

void GSMcmd(char *ch)
{
  while(*ch)
    if (UART_Remappable_Tx_Idle() == 1)
      UART_Remappable_Write(*ch++);
  UART_Remappable_Write(0x0D);        // Send CR - command terminate character
}

char GSM_Init(){
  char cmdTO = 0, readTO = 0;         // TimeOut counters
  char gsmRes[26]={0}, resCnt = 0;    // Responce from GSM module
  while(PWRMON != 0){};               // Wait for POWER to be generated by the GSM module
  Delay_ms(3500);
  while(cmdTO++ < 5){                 // Check the communication by sending AT command for few times
    ClearUART();
    GSMcmd("AT");                     // AT commad.
    while(readTO++ < 10){
      Delay_us(300);                  // 1/9600 * 3 = 312.5us takse a UART HW buffer to fill up.
      while(UART_Remappable_Data_Ready()){    // Place the received bytes to buffer array(gsamRes[])
        readTO = 0;
        gsmRes[resCnt++] = UART_Remappable_Read();
        gsmRes[resCnt] = 0;
        if (resCnt == 25){
         resCnt = 0;
        }
      }
    }
    readTO = 0;
    if (strstr(gsmRes,"AT\r\r\nOK\r\n")){     // Check for occurrence of expected string
      GSMcmd("ATE1");                         // Few more GSM module configuration
      GSMcmd("AT+CMGF=1");                    //   commands.
      return 0;
    }
  }
  return 1;
}

void SMSbegin(char *phoneNo){                 // Sending an SMS requires three easy steps
  char reply = 0;
  int timeout = 1;
                                              // 1. Begin with SMS command  +CMGS
  UART_Remappable_Write_Text("AT+CMGS=\"");   // AT+CMGS="+381632198765"[CR]
  UART_Remappable_Write_Text(phoneNo);
  GSMcmd("\"");
}

void SMSwrite(char *text){
  UART_Remappable_Write_Text(text);           // 2. After SMS command, SMS text is expected
}

void SMSsend(){
  GSMcmd("\x1A");                             // 3. At the end CTRL + Z is sent as terminating character
}
// Function sends an SMS to predefined number with predefined text(warning)
void SendSMS(char *phone){
  SMSbegin(phone);
  Delay_ms(100);
  SMSwrite("ATTENTION!!\r\n");
  SMSwrite("Motion detected!\r\n");
  SMSwrite("Siren will be activated in few seconds.");
  SMSsend();
}